=== modified file '.bzrignore'
--- .bzrignore	2005-10-03 16:53:39 +0000
+++ .bzrignore	2005-09-13 23:08:19 +0000
@@ -19,4 +19,3 @@
 ./ID
 ./tags
 .bzr-shelf
-bzrlib/plugins/*

=== modified file 'HACKING'
--- HACKING	2005-10-06 22:15:52 +0000
+++ HACKING	2005-08-25 12:46:42 +0000
@@ -1,25 +1,14 @@
 ============================
-Guidelines for modifying bzr
+guidelines for modifying bzr
 ============================
 
-.. contents::
-
-(The current version of this document is available in the file ``HACKING``
-in the source tree, or at http://bazaar-ng.org/hacking.html)
-
-Overall
-=======
-
 * New functionality should have test cases.  Preferably write the
   test before writing the code.
 
   In general, you can test at either the command-line level or the
   internal API level.  Choose whichever is appropriate: if adding a
   new command, or a new command option, then call through run_bzr().
-  It is not necessary to do both. Tests that test the command line level
-  are appropriate for checking the UI behaves well - bug fixes and
-  core improvements should be tested closer to the code that is doing the
-  work. Command line level tests should be placed in 'blackbox.py'.
+  It is not necessary to do both.
 
 * Before fixing a bug, write a test case so that it does not regress.
 
@@ -31,21 +20,17 @@
   function runs.  Import statements have a cost, so try to make sure
   they don't run inside hot functions.
 
+* Please write PEP-8__ compliant code.  
+
+  One often-missed requirement is that the first line of docstrings
+  should be a self-contained one-sentence summary.
+
+__ http://www.python.org/peps/pep-0008.html
+
 * Module names should always be given fully-qualified,
   i.e. ``bzrlib.hashcache`` not just ``hashcache``.
 
-Evolving interfaces
--------------------
-
-If you change the behaviour of an API in an incompatible way, please
-be sure to change its name as well. For instance, if I add a keyword
-parameter to branch.commit - that's fine. On the other hand, if I add
-a keyword parameter to branch.commit which is a *required* transaction
-object, I should rename the api - i.e. to 'branch.commit_transaction'.
-
-This will prevent users of the old api getting surprising results. 
-Instead, they will get an Attribute error as the api is missing, and
-will know to update their code. If in doubt, just ask on #bzr.
+
 
 Documentation
 =============
@@ -61,63 +46,6 @@
 should be done.
 
 
-API documentation
------------------
-
-Functions, methods, classes and modules should have docstrings
-describing how they are used. 
-
-The first line of the docstring should be a self-contained sentence.
-
-For the special case of Command classes, this acts as the user-visible
-documentation shown by the help command.
-
-The docstrings should be formatted as reStructuredText_ (like this
-document), suitable for processing using the epydoc_ tool into HTML
-documentation.
-
-.. _reStructuredText: http://docutils.sourceforge.net/rst.html
-.. _epydoc: http://epydoc.sourceforge.net/
-
-
-
-Coding style
-============
-
-Please write PEP-8__ compliant code.  
-
-One often-missed requirement is that the first line of docstrings
-should be a self-contained one-sentence summary.
-
-__ http://www.python.org/peps/pep-0008.html
-
-
-
-Naming
-------
-
-Functions, methods or members that are in some sense "private" are given
-a leading underscore prefix.  This is just a hint that code outside the
-implementation should probably not use that interface.
-
-We prefer class names to be concatenated capital words (``TestCase``)
-and variables, methods and functions to be lowercase words joined by
-underscores (``revision_id``, ``get_revision``).
-
-For the purposes of naming some names are treated as single compound
-words: "filename", "revno".
-
-Consider naming classes as nouns and functions/methods as verbs.
-
-
-Standard names
---------------
-
-``revision_id`` not ``rev_id`` or ``revid``
-
-Functions that transform one thing to another should be named ``x_to_y``
-(not ``x2y`` as occurs in some old code.)
-
 
 Writing output
 ==============
@@ -155,36 +83,17 @@
 The policy about how output is presented in the text-mode client
 should be only in the command-line tool.
 
-
 Writing tests
 =============
-In general tests should be placed in a file named testFOO.py where 
+In general tests should be placed in a file named test_FOO.py where 
 FOO is the logical thing under test. That file should be placed in the
 tests subdirectory under the package being tested.
 
-For example, tests for merge3 in bzrlib belong in bzrlib/tests/testmerge3.py.
-See bzrlib/selftest/testsampler.py for a template test script.
-
+For example, tests for merge3 in bzrlib belong in bzrlib/tests/test_merge3.py.
 
 Running tests
 =============
 Currently, bzr selftest is used to invoke tests.
 You can provide a pattern argument to run a subset. For example, 
-to run just the whitebox tests, run::
-
-  bzr selftest -v whitebox
-
-
-Errors and exceptions
-=====================
-
-[write me]
-
-
-Jargon
-======
-
-revno
-    Integer identifier for a revision on the main line of a branch.
-    Revision 0 is always the null revision; others are 1-based
-    indexes into the branch's revision history.
+to run just the whitebox tests, run bzr selftest --pattern .*whitebox.*
+

=== modified file 'NEWS'
--- NEWS	2005-10-06 13:08:14 +0000
+++ NEWS	2005-10-05 05:29:27 +0000
@@ -1,4 +1,4 @@
-bzr 0.1 2005-10-06
+DEVELOPMENT HEAD
 
 
   BUG FIXES:
@@ -9,13 +9,6 @@
     * Locking is now done with fcntl.lockf which works with NFS
       file systems. Contributed by Harald Meland.
 
-    * Commit will no longer commit without a log message, an 
-      error is returned instead. Contributed by Jelmer Vernooij.
-
-    * If you commit a specific file in a sub directory, any of its
-      parent directories that are added but not listed will be 
-      automatically included. Suggested by Michael Ellerman.
-
 
   IMPROVEMENTS:
 
@@ -36,11 +29,6 @@
     * 'bzr status' now shows unknown files inside a selected directory.
       Patch from Heikki Paajanen.
 
-    * Merge conflicts are recorded in .bzr. Two new commands 'conflicts'
-      and 'resolve' have needed added, which list and remove those 
-      merge conflicts respectively. A conflicted tree cannot be committed
-      in. Contributed by Aaron Bentley.
-
 
   INTERNALS:
 

=== modified file 'NEWS.developers'
--- NEWS.developers	2005-10-06 06:31:16 +0000
+++ NEWS.developers	2005-09-30 00:58:02 +0000
@@ -11,10 +11,3 @@
 
  * Move copy_branch to bzrlib.clone.copy_branch.  The destination
    directory is created if it doesn't exist.
-
- * Inventories now identify the files which were present by 
-   giving the revision *of that file*.
-
- * Inventory and Revision XML contains a version identifier.  
-   This must be consistent with the overall branch version
-   but allows for more flexibility in future upgrades.

=== modified file 'bzrlib/__init__.py'
--- bzrlib/__init__.py	2005-10-06 12:34:22 +0000
+++ bzrlib/__init__.py	2005-09-30 03:43:58 +0000
@@ -39,7 +39,7 @@
 del locale
 
 __copyright__ = "Copyright 2005 Canonical Development Ltd."
-__version__ = '0.1rc1'
+__version__ = '0.10pre(newformat)'
 
 
 def get_bzr_revision():

=== modified file 'bzrlib/branch.py'
--- bzrlib/branch.py	2005-10-06 07:31:42 +0000
+++ bzrlib/branch.py	2005-10-05 05:29:27 +0000
@@ -34,7 +34,7 @@
                            DivergedBranches, LockError, UnlistableStore,
                            UnlistableBranch, NoSuchFile)
 from bzrlib.textui import show_status
-from bzrlib.revision import Revision
+from bzrlib.revision import Revision, validate_revision_id, is_ancestor
 from bzrlib.delta import compare_trees
 from bzrlib.tree import EmptyTree, RevisionTree
 from bzrlib.inventory import Inventory
@@ -134,7 +134,6 @@
     def open(base):
         """Open an existing branch, rooted at 'base' (url)"""
         t = get_transport(base)
-        mutter("trying to open %r with transport %r", base, t)
         return _Branch(t)
 
     @staticmethod
@@ -466,7 +465,7 @@
             fmt = self.controlfile('branch-format', 'r').read()
         except NoSuchFile:
             raise NotBranchError(self.base)
-        mutter("got branch format %r", fmt)
+
         if fmt == BZR_BRANCH_FORMAT_5:
             self._branch_format = 5
         elif fmt == BZR_BRANCH_FORMAT_4:
@@ -781,17 +780,17 @@
         # But for now, just hash the contents.
         return bzrlib.osutils.sha_file(self.get_revision_xml_file(revision_id))
 
+    def _get_ancestry_weave(self):
+        return self.control_weaves.get_weave('ancestry')
+
     def get_ancestry(self, revision_id):
         """Return a list of revision-ids integrated by a revision.
-        
-        This currently returns a list, but the ordering is not guaranteed:
-        treat it as a set.
         """
+        # strip newlines
         if revision_id is None:
             return [None]
-        w = self.control_weaves.get_weave('inventory')
-        return [None] + map(w.idx_to_name,
-                            w.inclusions([w.lookup(revision_id)]))
+        w = self._get_ancestry_weave()
+        return [None] + [l[:-1] for l in w.get_iter(w.lookup(revision_id))]
 
     def get_inventory_weave(self):
         return self.control_weaves.get_weave('inventory')
@@ -1201,6 +1200,9 @@
     def add_pending_merge(self, *revision_ids):
         # TODO: Perhaps should check at this point that the
         # history of the revision is actually present?
+        for rev_id in revision_ids:
+            validate_revision_id(rev_id)
+
         p = self.pending_merges()
         updated = False
         for rev_id in revision_ids:

=== modified file 'bzrlib/builtins.py'
--- bzrlib/builtins.py	2005-10-06 13:08:14 +0000
+++ bzrlib/builtins.py	2005-10-05 02:47:53 +0000
@@ -323,10 +323,9 @@
     If branches have diverged, you can use 'bzr merge' to pull the text changes
     from one into the other.
     """
-    takes_options = ['remember']
     takes_args = ['location?']
 
-    def run(self, location=None, remember=False):
+    def run(self, location=None):
         from bzrlib.merge import merge
         import tempfile
         from shutil import rmtree
@@ -338,7 +337,7 @@
             if stored_loc is None:
                 raise BzrCommandError("No pull location known or specified.")
             else:
-                print "Using saved location: %s" % stored_loc
+                print "Using last location: %s" % stored_loc
                 location = stored_loc
         cache_root = tempfile.mkdtemp()
         from bzrlib.errors import DivergedBranches
@@ -358,7 +357,7 @@
                     "  Try merge.")
                 
             merge(('.', -1), ('.', old_revno), check_clean=False)
-            if stored_loc is None or remember:
+            if location != stored_loc:
                 br_to.set_parent(location)
         finally:
             rmtree(cache_root)
@@ -696,10 +695,11 @@
 
     --message allows you to give a regular expression, which will be evaluated
     so that only matching entries will be displayed.
+
+    TODO: Make --revision support uuid: and hash: [future tag:] notation.
+  
     """
 
-    # TODO: Make --revision support uuid: and hash: [future tag:] notation.
-
     takes_args = ['filename?']
     takes_options = ['forward', 'timezone', 'verbose', 'show-ids', 'revision',
                      'long', 'message', 'short',]
@@ -998,7 +998,7 @@
     
     def run(self, message=None, file=None, verbose=True, selected_list=None,
             unchanged=False):
-        from bzrlib.errors import PointlessCommit, ConflictsInTree
+        from bzrlib.errors import PointlessCommit
         from bzrlib.msgeditor import edit_commit_message
         from bzrlib.status import show_status
         from cStringIO import StringIO
@@ -1006,14 +1006,13 @@
         b = Branch.open_containing('.')
         if selected_list:
             selected_list = [b.relpath(s) for s in selected_list]
-
             
-        if message is None and not file:
+        if not message and not file:
             catcher = StringIO()
             show_status(b, specific_files=selected_list,
                         to_file=catcher)
             message = edit_commit_message(catcher.getvalue())
-
+            
             if message is None:
                 raise BzrCommandError("please specify a commit message"
                                       " with either --message or --file")
@@ -1024,9 +1023,6 @@
             import codecs
             message = codecs.open(file, 'rt', bzrlib.user_encoding).read()
 
-        if message == "":
-                raise BzrCommandError("empty commit message specified")
-            
         try:
             b.commit(message,
                      specific_files=selected_list,
@@ -1036,9 +1032,6 @@
             # perhaps prepare the commit; get the message; then actually commit
             raise BzrCommandError("no changes to commit",
                                   ["use --unchanged to commit anyhow"])
-        except ConflictsInTree:
-            raise BzrCommandError("Conflicts detected in working tree.  "
-                'Use "bzr conflicts" to list, "bzr resolve FILE" to resolve.')
 
 
 class cmd_check(Command):
@@ -1239,18 +1232,13 @@
     takes_args = ['branch?']
     takes_options = ['revision', 'force', 'merge-type']
 
-    def run(self, branch=None, revision=None, force=False, 
+    def run(self, branch='.', revision=None, force=False, 
             merge_type=None):
         from bzrlib.merge import merge
         from bzrlib.merge_core import ApplyMerge3
         if merge_type is None:
             merge_type = ApplyMerge3
-        if branch is None:
-            branch = Branch.open_containing('.').get_parent()
-            if branch is None:
-                raise BzrCommandError("No merge location known or specified.")
-            else:
-                print "Using saved location: %s" % branch 
+
         if revision is None or len(revision) < 1:
             base = [None, None]
             other = [branch, -1]

=== modified file 'bzrlib/changeset.py'
--- bzrlib/changeset.py	2005-10-03 19:50:36 +0000
+++ bzrlib/changeset.py	2005-10-03 01:42:16 +0000
@@ -358,10 +358,9 @@
         else:
             assert(status == 1)
             def get_lines(filename):
-                my_file = file(filename, "rb")
+                my_file = file(base, "rb")
                 lines = my_file.readlines()
                 my_file.close()
-                return lines
             base_lines = get_lines(base)
             other_lines = get_lines(other)
             conflict_handler.merge_conflict(new_file, filename, base_lines, 

=== modified file 'bzrlib/clone.py'
--- bzrlib/clone.py	2005-10-06 06:31:33 +0000
+++ bzrlib/clone.py	2005-10-04 04:49:21 +0000
@@ -117,7 +117,7 @@
 def _copy_control_weaves(branch_from, branch_to):
     to_control = branch_to.control_weaves
     from_control = branch_from.control_weaves
-    to_control.copy_multi(from_control, ['inventory'])
+    to_control.copy_multi(from_control, ['inventory', 'ancestry'])
 
     
 def copy_branch_slower(branch_from, to_location, revision=None, basis_branch=None):

=== modified file 'bzrlib/commands.py'
--- bzrlib/commands.py	2005-10-06 13:08:14 +0000
+++ bzrlib/commands.py	2005-10-04 02:30:58 +0000
@@ -355,7 +355,6 @@
     'root':                   str,
     'no-backup':              None,
     'pattern':                str,
-    'remember':               None,
     }
 
 SHORT_OPTIONS = {
@@ -625,10 +624,14 @@
 def run_bzr_catch_errors(argv):
     try:
         try:
-            return run_bzr(argv)
-        finally:
-            # do this here inside the exception wrappers to catch EPIPE
-            sys.stdout.flush()
+            try:
+                return run_bzr(argv)
+            finally:
+                # do this here inside the exception wrappers to catch EPIPE
+                sys.stdout.flush()
+        #wrap common errors as CommandErrors.
+        except (NotBranchError,), e:
+            raise BzrCommandError(str(e))
     except BzrCommandError, e:
         # command line syntax error, etc
         log_error(str(e))
@@ -650,8 +653,6 @@
             bzrlib.trace.note('broken pipe')
             return 2
         else:
-            ## import pdb
-            ## pdb.pm()
             bzrlib.trace.log_exception()
             return 2
 

=== modified file 'bzrlib/commit.py'
--- bzrlib/commit.py	2005-10-06 13:08:14 +0000
+++ bzrlib/commit.py	2005-10-06 00:52:53 +0000
@@ -74,12 +74,11 @@
 from bzrlib.branch import gen_file_id
 from bzrlib.errors import (BzrError, PointlessCommit,
                            HistoryMissing,
-                           ConflictsInTree
                            )
 from bzrlib.revision import Revision
 from bzrlib.trace import mutter, note, warning
 from bzrlib.xml5 import serializer_v5
-from bzrlib.inventory import Inventory, ROOT_ID
+from bzrlib.inventory import Inventory
 from bzrlib.weave import Weave
 from bzrlib.weavefile import read_weave, write_weave_v5
 from bzrlib.atomicfile import AtomicFile
@@ -98,38 +97,26 @@
 
 class NullCommitReporter(object):
     """I report on progress of a commit."""
-
-    def snapshot_change(self, change, path):
-        pass
-
-    def completed(self, revno, rev_id):
-        pass
-
-    def deleted(self, file_id):
-        pass
-
-    def escaped(self, escape_count, message):
-        pass
-
-    def missing(self, path):
-        pass
+    def added(self, path):
+        pass
+
+    def removed(self, path):
+        pass
+
+    def renamed(self, old_path, new_path):
+        pass
+
 
 class ReportCommitToLog(NullCommitReporter):
-
-    def snapshot_change(self, change, path):
-        note("%s %s", change, path)
-
-    def completed(self, revno, rev_id):
-        note('committed r%d {%s}', revno, rev_id)
-    
-    def deleted(self, file_id):
-        note('deleted %s', file_id)
-
-    def escaped(self, escape_count, message):
-        note("replaced %d control characters in message", escape_count)
-
-    def missing(self, path):
-        note('missing %s', path)
+    def added(self, path):
+        note('added %s', path)
+
+    def removed(self, path):
+        note('removed %s', path)
+
+    def renamed(self, old_path, new_path):
+        note('renamed %s => %s', old_path, new_path)
+
 
 class Commit(object):
     """Task of committing a new revision.
@@ -231,12 +218,11 @@
                     or self.new_inv != self.basis_inv):
                 raise PointlessCommit()
 
-            if len(list(self.work_tree.iter_conflicts()))>0:
-                raise ConflictsInTree
-
             self._record_inventory()
+            self._record_ancestry()
             self._make_revision()
-            self.reporter.completed(self.branch.revno()+1, self.rev_id)
+            note('committed r%d {%s}', (self.branch.revno() + 1),
+                 self.rev_id)
             self.branch.append_revision(self.rev_id)
             self.branch.set_pending_merges([])
         finally:
@@ -267,13 +253,33 @@
             lambda match: match.group(0).encode('unicode_escape'),
             self.message)
         if escape_count:
-            self.reporter.escaped(escape_count, self.message)
+            note("replaced %d control characters in message", escape_count)
+
+    def _record_ancestry(self):
+        """Append merged revision ancestry to the ancestry file.
+
+        This should be the merged ancestry of all parents, plus the
+        new revision id."""
+        s = self.branch.control_weaves
+        w = s.get_weave_or_empty('ancestry')
+        lines = self._make_ancestry(w)
+        w.add(self.rev_id, self.present_parents, lines)
+        s.put_weave('ancestry', w)
+
+    def _make_ancestry(self, ancestry_weave):
+        """Return merged ancestry lines.
+
+        The lines are revision-ids followed by newlines."""
+        parent_ancestries = [ancestry_weave.get(p) for p in self.present_parents]
+        new_lines = merge_ancestry_lines(self.rev_id, parent_ancestries)
+        mutter('merged ancestry of {%s}:\n%s', self.rev_id, ''.join(new_lines))
+        return new_lines
 
     def _gather_parents(self):
         """Record the parents of a merge for merge detection."""
         pending_merges = self.branch.pending_merges()
         self.parents = []
-        self.parent_invs = []
+        self.parent_trees = []
         self.present_parents = []
         precursor_id = self.branch.last_revision()
         if precursor_id:
@@ -281,7 +287,7 @@
         self.parents += pending_merges
         for revision in self.parents:
             if self.branch.has_revision(revision):
-                self.parent_invs.append(self.branch.get_inventory(revision))
+                self.parent_trees.append(self.branch.revision_tree(revision))
                 self.present_parents.append(revision)
 
     def _check_parents_present(self):
@@ -289,7 +295,7 @@
             mutter('commit parent revision {%s}', parent_id)
             if not self.branch.has_revision(parent_id):
                 if parent_id == self.branch.last_revision():
-                    warning("parent is missing %r", parent_id)
+                    warning("parent is pissing %r", parent_id)
                     raise HistoryMissing(self.branch, 'revision', parent_id)
                 else:
                     mutter("commit will ghost revision %r", parent_id)
@@ -309,6 +315,7 @@
         self.branch.revision_store.add(rev_tmp, self.rev_id)
         mutter('new revision_id is {%s}', self.rev_id)
 
+
     def _remove_deleted(self):
         """Remove deleted files from the working inventories.
 
@@ -326,34 +333,62 @@
             if specific and not is_inside_any(specific, path):
                 continue
             if not self.work_tree.has_filename(path):
-                self.reporter.missing(path)
-                deleted_ids.append((path, ie.file_id))
+                note('missing %s', path)
+                deleted_ids.append(ie.file_id)
         if deleted_ids:
-            deleted_ids.sort(reverse=True)
-            for path, file_id in deleted_ids:
-                del self.work_inv[file_id]
+            for file_id in deleted_ids:
+                if file_id in self.work_inv:
+                    del self.work_inv[file_id]
             self.branch._write_inventory(self.work_inv)
 
+
+    def _find_entry_parents(self, file_id):
+        """Return the text versions and hashes for all file parents.
+
+        Returned as a map from text version to inventory entry.
+
+        This is a set containing the file versions in all parents
+        revisions containing the file.  If the file is new, the set
+        will be empty."""
+        r = {}
+        for tree in self.parent_trees:
+            if file_id in tree.inventory:
+                ie = tree.inventory[file_id]
+                assert ie.file_id == file_id
+                if ie.revision in r:
+                    assert r[ie.revision] == ie
+                else:
+                    r[ie.revision] = ie
+        return r
+
     def _store_snapshot(self):
         """Pass over inventory and record a snapshot.
 
         Entries get a new revision when they are modified in 
         any way, which includes a merge with a new set of
-        parents that have the same entry. 
+        parents that have the same entry. Currently we do not
+        check for that set being ancestors of each other - and
+        we should - only parallel children should count for this
+        test see find_entry_parents to correct this. FIXME <---
+        I.e. if we are merging in revision FOO, and our
+        copy of file id BAR is identical to FOO.BAR, we should
+        generate a new revision of BAR IF and only IF FOO is
+        neither a child of our current tip, nor an ancestor of
+        our tip. The presence of FOO in our store should not 
+        affect this logic UNLESS we are doing a merge of FOO,
+        or a child of FOO.
         """
         # XXX: Need to think more here about when the user has
         # made a specific decision on a particular value -- c.f.
         # mark-merge.  
         for path, ie in self.new_inv.iter_entries():
-            previous_entries = ie.find_previous_heads(
-                self.parent_invs, 
-                self.weave_store.get_weave_or_empty(ie.file_id))
+            previous_entries = self._find_entry_parents(ie. file_id)
             if ie.revision is None:
                 change = ie.snapshot(self.rev_id, path, previous_entries,
                                      self.work_tree, self.weave_store)
             else:
                 change = "unchanged"
-            self.reporter.snapshot_change(change, path)
+            note("%s %s", change, path)
 
     def _populate_new_inv(self):
         """Build revision inventory.
@@ -373,34 +408,14 @@
             if self.specific_files:
                 if not is_inside_any(self.specific_files, path):
                     mutter('%s not selected for commit', path)
-                    self._carry_entry(file_id)
+                    self._carry_file(file_id)
                     continue
-                else:
-                    # this is selected, ensure its parents are too.
-                    parent_id = new_ie.parent_id
-                    while parent_id != ROOT_ID:
-                        if not self.new_inv.has_id(parent_id):
-                            ie = self._select_entry(self.work_inv[parent_id])
-                            mutter('%s selected for commit because of %s',
-                                   self.new_inv.id2path(parent_id), path)
-
-                        ie = self.new_inv[parent_id]
-                        if ie.revision is not None:
-                            ie.revision = None
-                            mutter('%s selected for commit because of %s',
-                                   self.new_inv.id2path(parent_id), path)
-                        parent_id = ie.parent_id
             mutter('%s selected for commit', path)
-            self._select_entry(new_ie)
-
-    def _select_entry(self, new_ie):
-        """Make new_ie be considered for committing."""
-        ie = new_ie.copy()
-        ie.revision = None
-        self.new_inv.add(ie)
-        return ie
-
-    def _carry_entry(self, file_id):
+            ie = new_ie.copy()
+            ie.revision = None
+            self.new_inv.add(ie)
+
+    def _carry_file(self, file_id):
         """Carry the file unchanged from the basis revision."""
         if self.basis_inv.has_id(file_id):
             self.new_inv.add(self.basis_inv[file_id].copy())
@@ -408,10 +423,38 @@
     def _report_deletes(self):
         for file_id in self.basis_inv:
             if file_id not in self.new_inv:
-                self.reporter.deleted(self.basis_inv.id2path(file_id))
+                note('deleted %s', self.basis_inv.id2path(file_id))
+
+
 
 def _gen_revision_id(branch, when):
     """Return new revision-id."""
     s = '%s-%s-' % (user_email(branch), compact_date(when))
     s += hexlify(rand_bytes(8))
     return s
+
+
+
+    
+def merge_ancestry_lines(rev_id, ancestries):
+    """Return merged ancestry lines.
+
+    rev_id -- id of the new revision
+    
+    ancestries -- a sequence of ancestries for parent revisions,
+        as newline-terminated line lists.
+    """
+    if len(ancestries) == 0:
+        return [rev_id + '\n']
+    seen = set(ancestries[0])
+    ancs = ancestries[0][:]    
+    for parent_ancestry in ancestries[1:]:
+        for line in parent_ancestry:
+            assert line[-1] == '\n'
+            if line not in seen:
+                ancs.append(line)
+                seen.add(line)
+    r = rev_id + '\n'
+    assert r not in seen
+    ancs.append(r)
+    return ancs

=== modified file 'bzrlib/errors.py'
--- bzrlib/errors.py	2005-10-06 13:08:14 +0000
+++ bzrlib/errors.py	2005-10-05 10:02:53 +0000
@@ -23,21 +23,16 @@
 # exceptions 
 class BzrError(StandardError):
     def __str__(self):
-        # XXX: Should we show the exception class in 
-        # exceptions that don't provide their own message?  
-        # maybe it should be done at a higher level
-        ## n = self.__class__.__name__ + ': '
-        n = ''
         if len(self.args) == 1:
-            return n + self.args[0]
+            return self.args[0]
         elif len(self.args) == 2:
             # further explanation or suggestions
             try:
-                return n + '\n  '.join([self.args[0]] + self.args[1])
+                return '\n  '.join([self.args[0]] + self.args[1])
             except TypeError:
-                return n + "%r" % self
+                return "%r" % self
         else:
-            return n + `self.args`
+            return `self.args`
 
 
 class BzrCheckError(BzrError):
@@ -55,14 +50,12 @@
 
 class BzrCommandError(BzrError):
     # Error from malformed user command
-    def __str__(self):
-        return self.args[0]
+    pass
 
 
 class NotBranchError(BzrError):
     """Specified path is not in a branch"""
-    def __str__(self):
-        return 'not a branch: %s' % self.args[0]
+    pass
 
 
 class NotVersionedError(BzrError):
@@ -214,10 +207,8 @@
 class NoSuchFile(TransportError, IOError):
     """A get() was issued for a file that doesn't exist."""
 
-    # XXX: Is multiple inheritance for exceptions really needed?
-
     def __str__(self):
-        return 'no such file: ' + self.msg
+        return self.msg
 
     def __init__(self, msg=None, orig_error=None):
         import errno
@@ -230,7 +221,6 @@
 
     mkdir() can throw this, but put() just overwites existing files.
     """
-    # XXX: Is multiple inheritance for exceptions really needed?
     def __init__(self, msg=None, orig_error=None):
         import errno
         TransportError.__init__(self, msg=msg, orig_error=orig_error)
@@ -244,6 +234,3 @@
     """The connection has been closed."""
     pass
 
-class ConflictsInTree(BzrError):
-    def __init__(self):
-        BzrError.__init__(self, "Working tree has conflicts.")

=== modified file 'bzrlib/fetch.py'
--- bzrlib/fetch.py	2005-10-06 06:31:33 +0000
+++ bzrlib/fetch.py	2005-10-05 10:02:53 +0000
@@ -190,6 +190,7 @@
             if not self.to_branch.has_revision(parent):
                 parents.pop(parents.index(parent))
         self._copy_inventory(rev_id, inv_xml, parents)
+        self._copy_ancestry(rev_id, parents)
         self.to_branch.revision_store.add(StringIO(rev_xml), rev_id)
         mutter('copied revision %s', rev_id)
 
@@ -198,6 +199,13 @@
         self.to_control.add_text('inventory', rev_id,
                                 split_lines(inv_xml), parent_ids)
 
+
+    def _copy_ancestry(self, rev_id, parent_ids):
+        ancestry_lines = self.from_control.get_lines('ancestry', rev_id)
+        self.to_control.add_text('ancestry', rev_id, ancestry_lines,
+                                 parent_ids)
+
+        
     def _copy_new_texts(self, rev_id, inv):
         """Copy any new texts occuring in this revision."""
         # TODO: Rather than writing out weaves every time, hold them

=== modified file 'bzrlib/inventory.py'
--- bzrlib/inventory.py	2005-10-06 02:51:02 +0000
+++ bzrlib/inventory.py	2005-10-05 10:02:53 +0000
@@ -146,47 +146,6 @@
              output_to, reverse=False):
         """Perform a diff between two entries of the same kind."""
 
-    def find_previous_heads(self, previous_inventories, entry_weave):
-        """Return the revisions and entries that directly preceed this.
-
-        Returned as a map from revision to inventory entry.
-
-        This is a map containing the file revisions in all parents
-        for which the file exists, and its revision is not a parent of
-        any other. If the file is new, the set will be empty.
-        """
-        def get_ancestors(weave, entry):
-            return set(map(weave.idx_to_name,
-                           weave.inclusions([weave.lookup(entry.revision)])))
-        heads = {}
-        head_ancestors = {}
-        for inv in previous_inventories:
-            if self.file_id in inv:
-                ie = inv[self.file_id]
-                assert ie.file_id == self.file_id
-                if ie.revision in heads:
-                    assert heads[ie.revision] == ie
-                else:
-                    # may want to add it.
-                    # may already be covered:
-                    already_present = 0 != len(
-                        [head for head in heads 
-                         if ie.revision in head_ancestors[head]])
-                    if already_present:
-                        # an ancestor of a known head.
-                        continue
-                    # definately a head:
-                    ancestors = get_ancestors(entry_weave, ie)
-                    # may knock something else out:
-                    check_heads = list(heads.keys())
-                    for head in check_heads:
-                        if head in ancestors:
-                            # this head is not really a head
-                            heads.pop(head)
-                    head_ancestors[ie.revision] = ancestors
-                    heads[ie.revision] = ie
-        return heads
-
     def get_tar_item(self, root, dp, now, tree):
         """Get a tarfile item and a file stream for its content."""
         item = tarfile.TarInfo(os.path.join(root, dp))
@@ -309,8 +268,8 @@
                    self.name,
                    self.parent_id))
 
-    def snapshot(self, revision, path, previous_entries,
-                 work_tree, weave_store):
+    def snapshot(self, revision, path, previous_entries, work_tree, 
+                 weave_store):
         """Make a snapshot of this entry which may or may not have changed.
         
         This means that all its fields are populated, that it has its

=== modified file 'bzrlib/log.py'
--- bzrlib/log.py	2005-10-06 04:02:15 +0000
+++ bzrlib/log.py	2005-09-19 08:02:41 +0000
@@ -109,21 +109,6 @@
     return rh
 
 
-def _get_revision_delta(branch, revno):
-    """Return the delta for a mainline revision.
-    
-    This is used to show summaries in verbose logs, and also for finding 
-    revisions which touch a given file."""
-    # FIXME: The current version is very inefficient; it retrieves all revisions
-    # twice and reads the weave twice.  We ought to keep revisions in memory 
-    # in case they're used again, either in a general cache or perhaps 
-    # in this code.
-    # XXX: What are we supposed to do when showing a summary for something 
-    # other than a mainline revision.  The delta to it's first parent, or
-    # (more useful) the delta to a nominated other revision.
-    return branch.get_revision_delta(revno)
-
-
 def show_log(branch,
              lf,
              specific_fileid=None,
@@ -196,7 +181,7 @@
 
     for revno, rev_id in cut_revs:
         if verbose or specific_fileid:
-            delta = _get_revision_delta(branch, revno)
+            delta = branch.get_revision_delta(revno)
             
         if specific_fileid:
             if not delta.touches_file_id(specific_fileid):
@@ -308,8 +293,12 @@
 
     def show(self, revno, rev, delta):
         raise NotImplementedError('not implemented in abstract base')
-
-    
+        
+
+
+
+
+
 class LongLogFormatter(LogFormatter):
     def show(self, revno, rev, delta):
         from osutils import format_date
@@ -374,12 +363,8 @@
 
 
 def log_formatter(name, *args, **kwargs):
-    """Construct a formatter from arguments.
-
-    name -- Name of the formatter to construct; currently 'long' and
-        'short' are supported.
-    """
     from bzrlib.errors import BzrCommandError
+    
     try:
         return FORMATTERS[name](*args, **kwargs)
     except IndexError:

=== modified file 'bzrlib/msgeditor.py'
--- bzrlib/msgeditor.py	2005-10-02 13:14:12 +0000
+++ bzrlib/msgeditor.py	2005-09-19 06:16:22 +0000
@@ -114,7 +114,7 @@
             msg.append(line)
             
         if len(msg) == 0:
-            return ""
+            return None
         # delete empty lines at the end
         del msg[lastline:]
         # add a newline at the end, if needed

=== removed file 'bzrlib/plugins/conflicts.py'
--- bzrlib/plugins/conflicts.py	2005-10-06 04:20:44 +0000
+++ bzrlib/plugins/conflicts.py	1970-01-01 00:00:00 +0000
@@ -1,68 +0,0 @@
-# Copyright (C) 2005 by Aaron Bentley
-
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-import bzrlib.status
-from bzrlib.branch import Branch
-from bzrlib.errors import BzrCommandError
-from bzrlib.commands import register_command
-from bzrlib.workingtree import CONFLICT_SUFFIXES
-import os
-import errno
-
-class cmd_conflicts(bzrlib.commands.Command):
-    """List files with conflicts.
-    (conflicts are determined by the presence of .BASE .TREE, and .OTHER 
-    files.)
-    """
-    def run(self):
-        for path in Branch.open_containing('.').working_tree().iter_conflicts():
-            print path
-
-register_command(cmd_conflicts)
-
-class cmd_resolve(bzrlib.commands.Command):
-    """Mark a conflict as resolved.
-    """
-    takes_args = ['file*']
-    takes_options = ['all']
-    def run(self, file_list=None, all=False):
-        if file_list is None:
-            if not all:
-                raise BzrCommandError(
-                    "command 'resolve' needs one or more FILE, or --all")
-            tree = Branch.open_containing('.').working_tree()
-            file_list = list(tree.abspath(f) for f in tree.iter_conflicts())
-        else:
-            if all:
-                raise BzrCommandError(
-                    "If --all is specified, no FILE may be provided")
-        for filename in file_list:
-            failures = 0
-            for suffix in CONFLICT_SUFFIXES:
-                try:
-                    os.unlink(filename+suffix)
-                except OSError, e:
-                    if e.errno != errno.ENOENT:
-                        raise
-                    else:
-                        failures += 1
-            if failures == len(CONFLICT_SUFFIXES):
-                if not os.path.exists(filename):
-                    print "%s does not exist" % filename
-                else:
-                    print "%s is not conflicted" % filename
-                        
-register_command(cmd_resolve)

=== modified file 'bzrlib/selftest/__init__.py'
--- bzrlib/selftest/__init__.py	2005-10-06 22:15:52 +0000
+++ bzrlib/selftest/__init__.py	2005-10-05 10:02:53 +0000
@@ -483,12 +483,10 @@
                    'bzrlib.selftest.whitebox',
                    'bzrlib.selftest.teststore',
                    'bzrlib.selftest.blackbox',
-                   'bzrlib.selftest.testsampler',
                    'bzrlib.selftest.testtransport',
                    'bzrlib.selftest.testgraph',
                    'bzrlib.selftest.testworkingtree',
                    'bzrlib.selftest.test_upgrade',
-                   'bzrlib.selftest.test_conflicts',
                    ]
 
     for m in (bzrlib.store, bzrlib.inventory, bzrlib.branch,

=== modified file 'bzrlib/selftest/blackbox.py'
--- bzrlib/selftest/blackbox.py	2005-10-06 13:08:14 +0000
+++ bzrlib/selftest/blackbox.py	2005-10-05 05:29:27 +0000
@@ -30,10 +30,9 @@
 import sys
 import os
 
+from bzrlib.selftest import TestCaseInTempDir, BzrTestBase
 from bzrlib.branch import Branch
-from bzrlib.errors import BzrCommandError
 from bzrlib.osutils import has_symlinks
-from bzrlib.selftest import TestCaseInTempDir, BzrTestBase
 from bzrlib.selftest.HTTPTestUtil import TestCaseWithWebserver
 
 
@@ -104,12 +103,6 @@
         self.runbzr("add hello.txt")
         self.runbzr("commit -m added")
 
-    def test_empty_commit_message(self):
-        self.runbzr("init")
-        file('foo.c', 'wt').write('int main() {}')
-        self.runbzr(['add', 'foo.c'])
-        self.runbzr(["commit", "-m", ""] , retcode=1) 
-
     def test_ignore_patterns(self):
         from bzrlib.branch import Branch
         
@@ -308,41 +301,7 @@
         a.get_revision_xml(b.last_revision())
         self.log('pending merges: %s', a.pending_merges())
         #        assert a.pending_merges() == [b.last_revision()], "Assertion %s %s" \
-        #        % (a.pending_merges(), b.last_patch())
-
-    def test_merge_with_missing_file(self):
-        """Merge handles missing file conflicts"""
-        os.mkdir('a')
-        os.chdir('a')
-        os.mkdir('sub')
-        print >> file('sub/a.txt', 'wb'), "hello"
-        print >> file('b.txt', 'wb'), "hello"
-        print >> file('sub/c.txt', 'wb'), "hello"
-        self.runbzr('init')
-        self.runbzr('add')
-        self.runbzr(('commit', '-m', 'added a'))
-        self.runbzr('branch . ../b')
-        print >> file('sub/a.txt', 'ab'), "there"
-        print >> file('b.txt', 'ab'), "there"
-        print >> file('sub/c.txt', 'ab'), "there"
-        self.runbzr(('commit', '-m', 'Added there'))
-        os.unlink('sub/a.txt')
-        os.unlink('sub/c.txt')
-        os.rmdir('sub')
-        os.unlink('b.txt')
-        self.runbzr(('commit', '-m', 'Removed a.txt'))
-        os.chdir('../b')
-        print >> file('sub/a.txt', 'ab'), "something"
-        print >> file('b.txt', 'ab'), "something"
-        print >> file('sub/c.txt', 'ab'), "something"
-        self.runbzr(('commit', '-m', 'Modified a.txt'))
-        self.runbzr('merge ../a/')
-        assert os.path.exists('sub/a.txt.THIS')
-        assert os.path.exists('sub/a.txt.BASE')
-        os.chdir('../a')
-        self.runbzr('merge ../b/')
-        assert os.path.exists('sub/a.txt.OTHER')
-        assert os.path.exists('sub/a.txt.BASE')
+        #        % (a.pending_merges(), b.last_revision())
 
     def test_merge_with_missing_file(self):
         """Merge handles missing file conflicts"""
@@ -427,34 +386,6 @@
         self.runbzr('commit -m blah8 --unchanged')
         self.runbzr('pull ../b')
         self.runbzr('pull ../b')
-
-    def test_locations(self):
-        """Using and remembering different locations"""
-        os.mkdir('a')
-        os.chdir('a')
-        self.runbzr('init')
-        self.runbzr('commit -m unchanged --unchanged')
-        self.runbzr('pull', retcode=1)
-        self.runbzr('merge', retcode=1)
-        self.runbzr('branch . ../b')
-        os.chdir('../b')
-        self.runbzr('pull')
-        self.runbzr('branch . ../c')
-        self.runbzr('pull ../c')
-        self.runbzr('merge')
-        os.chdir('../a')
-        self.runbzr('pull ../b')
-        self.runbzr('pull')
-        self.runbzr('pull ../c')
-        self.runbzr('branch ../c ../d')
-        shutil.rmtree('../c')
-        self.runbzr('pull')
-        os.chdir('../b')
-        self.runbzr('pull')
-        os.chdir('../d')
-        self.runbzr('pull', retcode=1)
-        self.runbzr('pull ../a --remember')
-        self.runbzr('pull')
         
     def test_add_reports(self):
         """add command prints the names of added files."""
@@ -475,40 +406,6 @@
         self.assertEquals(out, '')
         err.index('unknown command')
 
-    def test_conflicts(self):
-        """Handling of merge conflicts"""
-        os.mkdir('base')
-        os.chdir('base')
-        file('hello', 'wb').write("hi world")
-        file('answer', 'wb').write("42")
-        self.runbzr('init')
-        self.runbzr('add')
-        self.runbzr('commit -m base')
-        self.runbzr('branch . ../other')
-        self.runbzr('branch . ../this')
-        os.chdir('../other')
-        file('hello', 'wb').write("Hello.")
-        file('answer', 'wb').write("Is anyone there?")
-        self.runbzr('commit -m other')
-        os.chdir('../this')
-        file('hello', 'wb').write("Hello, world")
-        self.runbzr('mv answer question')
-        file('question', 'wb').write("What do you get when you multiply six"
-                                   "times nine?")
-        self.runbzr('commit -m this')
-        self.runbzr('merge ../other')
-        result = self.runbzr('conflicts', backtick=1)
-        self.assertEquals(result, "hello\nquestion\n")
-        result = self.runbzr('status', backtick=1)
-        assert "conflicts:\n  hello\n  question\n" in result, result
-        self.runbzr('resolve hello')
-        result = self.runbzr('conflicts', backtick=1)
-        self.assertEquals(result, "question\n")
-        self.runbzr('commit -m conflicts', retcode=1)
-        self.runbzr('resolve --all')
-        result = self.runbzr('conflicts', backtick=1)
-        self.runbzr('commit -m conflicts')
-        self.assertEquals(result, "")
 
 def listdir_sorted(dir):
     L = os.listdir(dir)

=== modified file 'bzrlib/selftest/test_ancestry.py'
--- bzrlib/selftest/test_ancestry.py	2005-10-06 06:31:33 +0000
+++ bzrlib/selftest/test_ancestry.py	2005-09-27 07:24:40 +0000
@@ -39,9 +39,6 @@
                  rev_id='tester@foo--2')
 
         ancs = b.get_ancestry('tester@foo--2')
-        self.assertEqual([None, 'tester@foo--1', 'tester@foo--2'], ancs)
-        self.assertEqual([None, 'tester@foo--1'], 
-                         b.get_ancestry('tester@foo--1'))
 
     def test_none_is_always_an_ancestor(self):
         b = Branch.initialize('.')

=== modified file 'bzrlib/selftest/test_commit.py'
--- bzrlib/selftest/test_commit.py	2005-10-06 07:03:33 +0000
+++ bzrlib/selftest/test_commit.py	2005-09-30 04:52:11 +0000
@@ -234,15 +234,3 @@
         for i in range(4):
             anc = b.get_ancestry(rev_ids[i])
             eq(anc, [None] + rev_ids[:i+1])
-
-    def test_commit_new_subdir_child_selective(self):
-        b = Branch.initialize('.')
-        self.build_tree(['dir/', 'dir/file1', 'dir/file2'])
-        b.add(['dir', 'dir/file1', 'dir/file2'],
-              ['dirid', 'file1id', 'file2id'])
-        b.commit('dir/file1', specific_files=['dir/file1'], rev_id='1')
-        inv = b.get_inventory('1')
-        self.assertEqual('1', inv['dirid'].revision)
-        self.assertEqual('1', inv['file1id'].revision)
-        # FIXME: This should raise a KeyError I think, rbc20051006
-        self.assertRaises(BzrError, inv.__getitem__, 'file2id')

=== removed file 'bzrlib/selftest/test_conflicts.py'
--- bzrlib/selftest/test_conflicts.py	2005-10-06 03:15:08 +0000
+++ bzrlib/selftest/test_conflicts.py	1970-01-01 00:00:00 +0000
@@ -1,44 +0,0 @@
-# Copyright (C) 2005 by Canonical Ltd
-
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-
-import os
-
-from bzrlib.selftest import TestCaseInTempDir
-from bzrlib.branch import Branch
-from bzrlib.commit import Commit
-
-
-# TODO: Test commit with some added, and added-but-missing files
-
-class TestConflicts(TestCaseInTempDir):
-
-    def test_conflicts(self):
-        """Conflicts are detected properly"""
-        b = Branch.initialize('.')
-        file('hello', 'w').write('hello world')
-        file('hello.BASE', 'w').write('hello world')
-        file('hello.sploo.BASE', 'w').write('yellow world')
-        tree = b.working_tree()
-        self.assertEqual(len(list(tree.list_files())), 3)
-        conflicts = list(tree.iter_conflicts())
-        self.assertEqual(len(conflicts), 2)
-        assert 'hello' in conflicts
-        assert 'hello.sploo' in conflicts
-        os.unlink('hello.BASE')
-        os.unlink('hello.sploo.BASE')
-        self.assertEqual(len(list(tree.iter_conflicts())), 0)
-

=== modified file 'bzrlib/selftest/test_upgrade.py'
--- bzrlib/selftest/test_upgrade.py	2005-10-06 11:26:51 +0000
+++ bzrlib/selftest/test_upgrade.py	2005-10-05 10:02:53 +0000
@@ -1,15 +1,15 @@
 # Copyright (C) 2005 by Canonical Ltd
-#
+
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
 # the Free Software Foundation; either version 2 of the License, or
 # (at your option) any later version.
-#
+
 # This program is distributed in the hope that it will be useful,
 # but WITHOUT ANY WARRANTY; without even the implied warranty of
 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 # GNU General Public License for more details.
-#
+
 # You should have received a copy of the GNU General Public License
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

=== modified file 'bzrlib/selftest/test_weave.py'
--- bzrlib/selftest/test_weave.py	2005-10-06 10:53:12 +0000
+++ bzrlib/selftest/test_weave.py	2005-10-05 04:38:09 +0000
@@ -840,58 +840,6 @@
         eq(wa.get_lines('b1'),
            ['hello\n', 'pale blue\n', 'world\n'])
 
-    def test_join_parent_disagreement(self):
-        """Cannot join weaves with different parents for a version."""
-        wa = Weave()
-        wb = Weave()
-        wa.add('v1', [], ['hello\n'])
-        wb.add('v0', [], [])
-        wb.add('v1', ['v0'], ['hello\n'])
-        self.assertRaises(WeaveError,
-                          wa.join, wb)
-
-    def test_join_text_disagreement(self):
-        """Cannot join weaves with different texts for a version."""
-        wa = Weave()
-        wb = Weave()
-        wa.add('v1', [], ['hello\n'])
-        wb.add('v1', [], ['not\n', 'hello\n'])
-        self.assertRaises(WeaveError,
-                          wa.join, wb)
-
-    def test_join_unordered(self):
-        """Join weaves where indexes differ.
-        
-        The source weave contains a different version at index 0."""
-        wa = self.weave1.copy()
-        wb = Weave()
-        wb.add('x1', [], ['line from x1\n'])
-        wb.add('v1', [], ['hello\n'])
-        wb.add('v2', ['v1'], ['hello\n', 'world\n'])
-        wa.join(wb)
-        eq = self.assertEquals
-        eq(sorted(wa.iter_names()), ['v1', 'v2', 'v3', 'x1',])
-        eq(wa.get_text('x1'), 'line from x1\n')
-
-    def test_join_with_ghosts(self):
-        """Join that inserts parents of an existing revision.
-
-        This can happen when merging from another branch who
-        knows about revisions the destination does not.  In 
-        this test the second weave knows of an additional parent of 
-        v2.  Any revisions which are in common still have to have the 
-        same text."""
-        return ###############################
-        wa = self.weave1.copy()
-        wb = Weave()
-        wb.add('x1', [], ['line from x1\n'])
-        wb.add('v1', [], ['hello\n'])
-        wb.add('v2', ['v1', 'x1'], ['hello\n', 'world\n'])
-        wa.join(wb)
-        eq = self.assertEquals
-        eq(sorted(wa.iter_names()), ['v1', 'v2', 'v3', 'x1',])
-        eq(wa.get_text('x1'), 'line from x1\n')
-
 
 if __name__ == '__main__':
     import sys

=== modified file 'bzrlib/selftest/testfetch.py'
--- bzrlib/selftest/testfetch.py	2005-10-06 06:31:33 +0000
+++ bzrlib/selftest/testfetch.py	2005-10-05 06:44:02 +0000
@@ -56,7 +56,7 @@
     assert has_revision(br_a, br_b.revision_history()[5])
 
     # When a non-branch ancestor is missing, it should be unlisted...
-    # as its not reference from the inventory weave.
+    # as its not present in the ancestry weave.
     br_b4 = new_branch('br_4')
     count, failures = greedy_fetch(br_b4, br_b)
     self.assertEqual(count, 7)

=== modified file 'bzrlib/selftest/testinv.py'
--- bzrlib/selftest/testinv.py	2005-10-06 02:51:02 +0000
+++ bzrlib/selftest/testinv.py	2005-10-06 00:52:53 +0000
@@ -18,7 +18,6 @@
 import os
 
 from bzrlib.branch import Branch
-from bzrlib.clone import copy_branch
 import bzrlib.errors as errors
 from bzrlib.diff import internal_diff
 from bzrlib.inventory import Inventory, ROOT_ID
@@ -271,7 +270,6 @@
     def test_snapshot_merge_identical_different_revid(self):
         # This tests that a commit with two identical parents, one of which has
         # a different revision id, results in a new revision id in the entry.
-        # 1->other, commit a merge of other against 1, results in 2.
         other_ie = inventory.InventoryFile('fileid', 'newname', self.file_1.parent_id)
         other_ie = inventory.InventoryFile('fileid', 'file', self.file_1.parent_id)
         other_ie.revision = '1'
@@ -296,63 +294,3 @@
                                   self.branch.weave_store)
         # expected outcome - file_1 has a revision id of '2'
         self.assertEqual(self.file_active.revision, '2')
-
-
-class TestPreviousHeads(TestCaseInTempDir):
-
-    def setUp(self):
-        # we want several inventories, that respectively
-        # give use the following scenarios:
-        # A) fileid not in any inventory (A),
-        # B) fileid present in one inventory (B) and (A,B)
-        # C) fileid present in two inventories, and they
-        #   are not mutual descendents (B, C)
-        # D) fileid present in two inventories and one is
-        #   a descendent of the other. (B, D)
-        super(TestPreviousHeads, self).setUp()
-        self.build_tree(['file'])
-        self.branch = Branch.initialize('.')
-        self.branch.commit('new branch', allow_pointless=True, rev_id='A')
-        self.inv_A = self.branch.get_inventory('A')
-        self.branch.add(['file'], ['fileid'])
-        self.branch.commit('add file', rev_id='B')
-        self.inv_B = self.branch.get_inventory('B')
-        self.branch.put_controlfile('revision-history', 'A\n')
-        self.assertEqual(self.branch.revision_history(), ['A'])
-        self.branch.commit('another add of file', rev_id='C')
-        self.inv_C = self.branch.get_inventory('C')
-        self.branch.add_pending_merge('B')
-        self.branch.commit('merge in B', rev_id='D')
-        self.inv_D = self.branch.get_inventory('D')
-        self.file_active = self.branch.working_tree().inventory['fileid']
-        self.weave = self.branch.weave_store.get_weave('fileid')
-        
-    def get_previous_heads(self, inventories):
-        return self.file_active.find_previous_heads(inventories, self.weave)
-        
-    def test_fileid_in_no_inventory(self):
-        self.assertEqual({}, self.get_previous_heads([self.inv_A]))
-
-    def test_fileid_in_one_inventory(self):
-        self.assertEqual({'B':self.inv_B['fileid']},
-                         self.get_previous_heads([self.inv_B]))
-        self.assertEqual({'B':self.inv_B['fileid']},
-                         self.get_previous_heads([self.inv_A, self.inv_B]))
-        self.assertEqual({'B':self.inv_B['fileid']},
-                         self.get_previous_heads([self.inv_B, self.inv_A]))
-
-    def test_fileid_in_two_inventories_gives_both_entries(self):
-        self.assertEqual({'B':self.inv_B['fileid'],
-                          'C':self.inv_C['fileid']},
-                          self.get_previous_heads([self.inv_B, self.inv_C]))
-        self.assertEqual({'B':self.inv_B['fileid'],
-                          'C':self.inv_C['fileid']},
-                          self.get_previous_heads([self.inv_C, self.inv_B]))
-
-    def test_fileid_in_two_inventories_already_merged_gives_head(self):
-        self.assertEqual({'D':self.inv_D['fileid']},
-                         self.get_previous_heads([self.inv_B, self.inv_D]))
-        self.assertEqual({'D':self.inv_D['fileid']},
-                         self.get_previous_heads([self.inv_D, self.inv_B]))
-
-    # TODO: test two inventories with the same file revision 

=== removed file 'bzrlib/selftest/testsampler.py'
--- bzrlib/selftest/testsampler.py	2005-10-06 11:40:12 +0000
+++ bzrlib/selftest/testsampler.py	1970-01-01 00:00:00 +0000
@@ -1,39 +0,0 @@
-# Copyright (C) 2005 by Canonical Ltd
-#   Authors: Robert Collins <robert.collins@canonical.com>
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-"""Document what this test file is expecting to test here.
-
-If you need more than one line, make the first line a good sentence on its
-own and add more explanation here, like this.
-
-Be sure to register your new test script in bzrlib/selftest/__init__.py -
-search for sampler in there.
-"""
-
-# import system imports here
-import os
-import sys
-
-#import bzrlib specific imports here
-from bzrlib.selftest import TestCaseInTempDir
-
-
-# Now we need a test script:
-class DemoTest(TestCaseInTempDir):
-
-    def test_nothing(self):
-        self.assertEqual(1,1)

=== modified file 'bzrlib/status.py'
--- bzrlib/status.py	2005-10-06 13:08:14 +0000
+++ bzrlib/status.py	2005-10-03 01:53:47 +0000
@@ -1,22 +1,19 @@
 # (C) 2005 Canonical Ltd
-#
+
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
 # the Free Software Foundation; either version 2 of the License, or
 # (at your option) any later version.
-#
+
 # This program is distributed in the hope that it will be useful,
 # but WITHOUT ANY WARRANTY; without even the implied warranty of
 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 # GNU General Public License for more details.
-#
+
 # You should have received a copy of the GNU General Public License
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
-import sys
-from bzrlib.osutils import is_inside_any
-from bzrlib.delta import compare_trees
 
 
 def show_status(branch, show_unchanged=False,
@@ -47,6 +44,10 @@
         If one revision show compared it with working tree.
         If two revisions show status between first and second.
     """
+    import sys
+    from bzrlib.osutils import is_inside_any
+    from bzrlib.delta import compare_trees
+
     if to_file == None:
         to_file = sys.stdout
     
@@ -81,10 +82,15 @@
                    show_unchanged=show_unchanged)
 
         if new_is_working_tree:
-            conflicts = new.iter_conflicts()
             unknowns = new.unknowns()
-            list_paths('unknown', unknowns, specific_files, to_file)
-            list_paths('conflicts', conflicts, specific_files, to_file)
+            done_header = False
+            for path in unknowns:
+                if specific_files and not is_inside_any(specific_files, path):
+                    continue
+                if not done_header:
+                    print >>to_file, 'unknown:'
+                    done_header = True
+                print >>to_file, ' ', path
             if show_pending and len(branch.pending_merges()) > 0:
                 print >>to_file, 'pending merges:'
                 for merge in branch.pending_merges():
@@ -92,12 +98,3 @@
     finally:
         branch.unlock()
         
-def list_paths(header, paths, specific_files, to_file):
-    done_header = False
-    for path in paths:
-        if specific_files and not is_inside_any(specific_files, path):
-            continue
-        if not done_header:
-            print >>to_file, '%s:' % header
-            done_header = True
-        print >>to_file, ' ', path

=== modified file 'bzrlib/trace.py'
--- bzrlib/trace.py	2005-10-06 07:28:41 +0000
+++ bzrlib/trace.py	2005-09-27 07:24:40 +0000
@@ -54,10 +54,9 @@
     # can get the exception details is we suppress them here.
 
     def format(self, record):
+        s = 'bzr: '
         if record.levelno >= logging.WARNING:
-            s = 'bzr: ' + record.levelname + ': '
-        else:
-            s = ''
+            s += record.levelname + ': '
             
         s += record.getMessage()
 
@@ -164,9 +163,10 @@
     if msg == None:
         ei = sys.exc_info()
         msg = str(ei[1])
+
     if msg and (msg[-1] == '\n'):
         msg = msg[:-1]
-    ## msg = "(%s) %s" % (str(type(ei[1])), msg)
+        
     _bzr_logger.exception(msg)
 
 

=== modified file 'bzrlib/upgrade.py'
--- bzrlib/upgrade.py	2005-10-06 06:31:33 +0000
+++ bzrlib/upgrade.py	2005-10-05 10:14:00 +0000
@@ -95,6 +95,7 @@
 from bzrlib.xml5 import serializer_v5
 from bzrlib.trace import mutter, note, warning, enable_default_logging
 from bzrlib.osutils import sha_strings, sha_string
+from bzrlib.commit import merge_ancestry_lines
 
 
 class Convert(object):
@@ -118,6 +119,8 @@
         if not os.path.isdir(self.base + '/.bzr/weaves'):
             os.mkdir(self.base + '/.bzr/weaves')
         self.inv_weave = Weave('inventory')
+        self.anc_weave = Weave('ancestry')
+        self.ancestries = {}
         # holds in-memory weaves for all files
         self.text_weaves = {}
         os.remove(self.branch.controlfilename('branch-format'))
@@ -194,6 +197,7 @@
 
     def _write_all_weaves(self):
         write_a_weave(self.inv_weave, self.base + '/.bzr/inventory.weave')
+        write_a_weave(self.anc_weave, self.base + '/.bzr/ancestry.weave')
         i = 0
         try:
             for file_id, file_weave in self.text_weaves.items():
@@ -269,6 +273,7 @@
                            if p not in self.absent_revisions]
         self._convert_revision_contents(rev, inv, present_parents)
         self._store_new_weave(rev, inv, present_parents)
+        self._make_rev_ancestry(rev, present_parents)
         self.converted_revs.add(rev_id)
 
 
@@ -290,6 +295,24 @@
                            new_inv_sha1)
         rev.inventory_sha1 = new_inv_sha1
 
+
+    def _make_rev_ancestry(self, rev, present_parents):
+        rev_id = rev.revision_id
+        for parent_id in present_parents:
+            assert parent_id in self.converted_revs
+        if present_parents:
+            lines = list(self.anc_weave.mash_iter(present_parents))
+        else:
+            lines = []
+        lines.append(rev_id + '\n')
+        if __debug__:
+            parent_ancestries = [self.ancestries[p] for p in present_parents]
+            new_lines = merge_ancestry_lines(rev_id, parent_ancestries)
+            assert set(lines) == set(new_lines)
+            self.ancestries[rev_id] = new_lines
+        self.anc_weave.add(rev_id, present_parents, lines)
+
+
     def _convert_revision_contents(self, rev, inv, present_parents):
         """Convert all the files within a revision.
 
@@ -317,19 +340,27 @@
             w = Weave(file_id)
             self.text_weaves[file_id] = w
         text_changed = False
-        previous_entries = ie.find_previous_heads(parent_invs, w)
-        for old_revision in previous_entries:
+        previous_revisions = {}
+        for parent_inv in parent_invs:
+            if parent_inv.has_id(file_id):
+                previous_ie = parent_inv[file_id]
+                if previous_ie.revision in previous_revisions:
+                    assert previous_revisions[previous_ie.revision] == previous_ie
+                else:
+                    previous_revisions[previous_ie.revision] = previous_ie
+                old_revision = previous_ie.revision
+        for old_revision in previous_revisions:
                 # if this fails, its a ghost ?
                 assert old_revision in self.converted_revs 
-        self.snapshot_ie(previous_entries, ie, w, rev_id)
+        self.snapshot_ie(previous_revisions, ie, w, rev_id)
         del ie.text_id
         assert getattr(ie, 'revision', None) is not None
 
     def snapshot_ie(self, previous_revisions, ie, w, rev_id):
         # TODO: convert this logic, which is ~= snapshot to
         # a call to:. This needs the path figured out. rather than a work_tree
-        # a v4 revision_tree can be given, or something that looks enough like
-        # one to give the file content to the entry if it needs it.
+        # a v4 revision_tree can be given, or something that can give the
+        # text for the ie if it needs it.
         # and we need something that looks like a weave store for snapshot to 
         # save against.
         #ie.snapshot(rev, PATH, previous_revisions, REVISION_TREE, InMemoryWeaveStore(self.text_weaves))

=== modified file 'bzrlib/weave.py'
--- bzrlib/weave.py	2005-10-06 08:11:46 +0000
+++ bzrlib/weave.py	2005-10-05 04:38:09 +0000
@@ -805,12 +805,6 @@
 
     def _check_version_consistent(self, other, other_idx, name):
         """Check if a version in consistent in this and other.
-
-        To be consistent it must have:
-
-         * the same text
-         * the same direct parents (by name, not index, and disregarding
-           order)
         
         If present & correct return True;
         if not present in self return False; 
@@ -818,19 +812,11 @@
         this_idx = self._name_map.get(name, -1)
         if this_idx != -1:
             if self._sha1s[this_idx] != other._sha1s[other_idx]:
-                raise WeaveError("inconsistent texts for version {%s} "
-                                 "when joining weaves"
-                                 % (name))
-            self_parents = self._parents[this_idx]
-            other_parents = other._parents[other_idx]
-            n1 = [self._names[i] for i in self_parents]
-            n2 = [other._names[i] for i in other_parents]
-            n1.sort()
-            n2.sort()
-            if n1 != n2:
-                raise WeaveError("inconsistent parents for version {%s}: "
-                                 "%s vs %s"
-                                 % (name, n1, n2))
+                raise WeaveError("inconsistent texts for version {%s} in %r and %r"
+                                 % (name, self, other))
+            elif set(self._parents[this_idx]) != set(other._parents[other_idx]):
+                raise WeaveError("inconsistent parents for version {%s} in %r and %r"
+                                 % (name, self, other))
             else:
                 return True         # ok!
         else:

=== modified file 'bzrlib/workingtree.py'
--- bzrlib/workingtree.py	2005-10-06 04:29:10 +0000
+++ bzrlib/workingtree.py	2005-10-03 03:30:02 +0000
@@ -275,15 +275,6 @@
             if not self.is_ignored(subp):
                 yield subp
 
-    def iter_conflicts(self):
-        conflicted = set()
-        for path in (s[0] for s in self.list_files()):
-            stem = get_conflicted_stem(path)
-            if stem is None:
-                continue
-            if stem not in conflicted:
-                conflicted.add(stem)
-                yield stem
 
     def extras(self):
         """Yield all unknown files in this WorkingTree.
@@ -375,9 +366,4 @@
                     return pat
         else:
             return None
-
-CONFLICT_SUFFIXES = ('.THIS', '.BASE', '.OTHER')
-def get_conflicted_stem(path):
-    for suffix in CONFLICT_SUFFIXES:
-        if path.endswith(suffix):
-            return path[:-len(suffix)]
+        

=== modified file 'bzrlib/xml5.py'
--- bzrlib/xml5.py	2005-10-06 06:31:16 +0000
+++ bzrlib/xml5.py	2005-10-03 15:19:25 +0000
@@ -35,8 +35,7 @@
     
     def _pack_inventory(self, inv):
         """Convert to XML Element"""
-        e = Element('inventory',
-                    format='5')
+        e = Element('inventory')
         e.text = '\n'
         if inv.root.file_id not in (None, ROOT_ID):
             e.set('file_id', inv.root.file_id)
@@ -83,14 +82,15 @@
                        timestamp = '%.9f' % rev.timestamp,
                        revision_id = rev.revision_id,
                        inventory_sha1 = rev.inventory_sha1,
-                       format='5',
                        )
         if rev.timezone:
             root.set('timezone', str(rev.timezone))
         root.text = '\n'
+
         msg = SubElement(root, 'message')
         msg.text = rev.message
         msg.tail = '\n'
+
         if rev.parent_ids:
             pelts = SubElement(root, 'parents')
             pelts.tail = pelts.text = '\n'
@@ -100,6 +100,7 @@
                 p.tail = '\n'
                 p.set('revision_id', parent_id)
         return root
+
     
 
     def _unpack_inventory(self, elt):
@@ -107,11 +108,6 @@
         """
         assert elt.tag == 'inventory'
         root_id = elt.get('file_id') or ROOT_ID
-        format = elt.get('format')
-        if format is not None:
-            if format != '5':
-                raise BzrError("invalid format version %r on inventory"
-                                % format)
         inv = Inventory(root_id)
         for e in elt:
             ie = self._unpack_entry(e)
@@ -158,16 +154,13 @@
     def _unpack_revision(self, elt):
         """XML Element -> Revision object"""
         assert elt.tag == 'revision'
-        format = elt.get('format')
-        if format is not None:
-            if format != '5':
-                raise BzrError("invalid format version %r on inventory"
-                                % format)
+        
         rev = Revision(committer = elt.get('committer'),
                        timestamp = float(elt.get('timestamp')),
                        revision_id = elt.get('revision_id'),
                        inventory_sha1 = elt.get('inventory_sha1')
                        )
+
         parents = elt.find('parents') or []
         for p in parents:
             assert p.tag == 'revision_ref', \
@@ -181,4 +174,5 @@
         return rev
 
 
+
 serializer_v5 = Serializer_v5()

=== modified file 'setup.py'
--- setup.py	2005-10-06 12:34:22 +0000
+++ setup.py	2005-09-23 09:25:16 +0000
@@ -51,7 +51,7 @@
 ########################
 
 setup(name='bzr',
-      version='0.1',
+      version='0.0.6',
       author='Martin Pool',
       author_email='mbp@sourcefrog.net',
       url='http://www.bazaar-ng.org/',
@@ -61,8 +61,6 @@
                 'bzrlib.plugins',
                 'bzrlib.selftest',
                 'bzrlib.util',
-                'bzrlib.transport',
-                'bzrlib.store',
                 'bzrlib.util.elementtree',
                 'bzrlib.util.effbot.org',
                 ],

